/********************************************************
 *            ####   #####   #####
 *           #    #  #    #  #    #
 *           #       #    #  #####
 *           #  ###  #####   #    #
 *           #    #  #   #   #    #
 *            ####   #    #  #####
 *
 * File:        grbevent.h
 * Description: GRB event structure.
 * Comments:
 * Author:      HHh
 * Created:     2001/05/22
 * Modified:
 *
 ********************************************************/

#ifndef __GRBEVENT_H
#define __GRBEVENT_H

#define NO_OF_SCALERS 8
//////#define NO_OF_SCALERS 3

#define GRB_MAGIC_NUMBER 0x29111968
#define GRB_MAGIC_NUMBER_SWAP2 0x11296819
#define GRB_MAGIC_NUMBER_SWAP4 0x68191129

struct GRBEvent{
  unsigned int EventNo;
  unsigned short data[6];
  unsigned int r[NO_OF_SCALERS][80];
};

#endif /* __GRBEVENT_H */

